// total height 
H = 142 ;
// outside diameter 
D = 18 ;
// diameter floor 
Db= 25 ;
// diameter of the ventilation holes 
L = 3.0 ;
// nummber of the holes in a slice
n= 10 ;
// Wall thickness
Ws= 1.8 ;
// Fineness of circle calculation body
F = 90 ;
// Fineness of circle calculation holes
Fl = 12 ;
// Decision Es = 0 no cutout / Es = 1 cutout 
Es= 1 ;
//
//
//
step=360/n;
difference (){
// Rohling
union () {
// Zylinder
cylinder (d=D,h=H-0.5*D,$fn=F);
// Kopf
translate([0,0,H-0.5*D])
sphere(d=D,$fn=F);
// Boden
cylinder (d=Db,h=Ws,$fn=F);
}// ende union Rohling
//
//
// Abzüge
union () {
// Zylinder innen
translate([0,0,-1])
cylinder (d=D-2*Ws,h=H-0.5*D+1,$fn=F);
// Kopf innen
translate([0,0,H-0.5*D])
sphere(d=D-2*Ws,$fn=F);
// 
// Löcher
// gerade Zahl
for (i = [L*1.5:L*2:H-D/2]) { // Höhe 
for (w = [0:360/n:359]) { // Winkel
translate([0,0,i])
rotate([w,90,0])
cylinder (d=L,h=Db,$fn=Fl);
}// ende for Winkel
}// ende for Höhe
//
// ungerade Zahl
for (i = [L*2.5:L*2:H-D/2]) { // Höhe 
for (w = [(360/n)/2:360/n:359]) { // Winkel
translate([0,0,i])
rotate([w,90,0])
cylinder (d=L,h=Db,$fn=Fl);
}// ende for Winkel
}// ende for Höhe
//
// Kopf spitze
translate([0,0,H])
cylinder (d=L,h=Db,center=true,$fn=Fl);
//
for (y = [(360/n)/2:360/floor(n/2):359]) { // Spitze winkel 1
translate([0,0,H-D/2])
rotate([0,0,y])
rotate([0,30,0])
translate([0,0,D/2])
cylinder (d=L,h=Db/2,center=true,$fn=Fl);
}// ende for Spitze winkel 1
//
//
for (y = [0:360/n:359]) { // Spitze winkel 2
translate([0,0,H-D/2])
rotate([0,0,y])
rotate([0,57,0])
translate([0,0,D/2])
cylinder (d=L,h=Db/2,center=true,$fn=Fl);
}// ende for Spitze winkel 2
//
for (y = [(360/n)/2:360/n:359]) { // Spitze winkel 3
translate([0,0,H-D/2])
rotate([0,0,y])
rotate([0,80,0])
translate([0,0,D/2])
cylinder (d=L,h=Db/2,center=true,$fn=Fl);
}// ende for Spitze winkel 3
//
if (Es==1){
translate([-Db/2,D/2+1,-1])
cube([Db,Db,Ws+2]);
}
}// ende union Abzüge
}// ende difference
